# GruffTemplate

require 'gruff'

class GruffTempPlugin
  class Template
    def initialize(view)
      @view = view
    end
    
    def render(template, locals)
      y = YAML.load(@view.render_template('erb', template, nil, locals))

      if(graph_class = Gruff.const_get(y['type'])) then
        if(graph_class <= Gruff::Base) then          
          g = graph_class.new(y['width'])
          y.delete('width'); y.delete('type');
          y.each { |k,v|
            if(k == 'data') then
              if(! (v.class <= Array)) then
                v = [v]
              end
              v.each { |x|
                g.data(x['name'], x['values'], x['color'])
              }
            elsif(k == 'theme') then
              g.send("theme_#{v}")
            else
              g.send(k+"=", v)
            end
          }
          @view.controller.headers["Content-Type"] = 'image/png'
          @view.controller.headers["Content-Disposition"] = "inline;"
          g.to_blob
        end
      end
    end
  end
end


          
